--[[
    Copyright (C) 2006-2007 Nymbia
    Copyright (C) 2010 Hendrik "Nevcairiel" Leppkes < h.leppkes@gmail.com >

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
]]
local PAB = LibStub("AceAddon-3.0"):GetAddon("ProfilesActionBars")

----------------------------

local getOpt, setOpt
do
   function getOpt(info)
      local key = info[#info]
      local boolean_conversion = false
      
      -- Ugly hack because lua sees false and 0 different from perl
      if PABdb.char[key] == 0 then
         boolean_conversion = false
      elseif PABdb.char[key] == 1 then
         boolean_conversion = true
      else
         boolean_conversion = PABdb.char[key]
      end
      
      return boolean_conversion
   end
   
   function setOpt(info, value)
      local key = info[#info]
      local boolean_conversion = false
      
      -- Ugly hack because lua sees false and 0 different from perl
      if value == false then
         boolean_conversion = 0
      elseif value == true then
         boolean_conversion = 1
      else
         boolean_conversion = value
      end
      
      PABdb.char[key] = boolean_conversion
      return boolean_conversion
   end
   
	function getMinimapValue()
		return PABglobaldb.global.minimap.hide
	end
end

local options, moduleOptions = nil, {}
local function getOptions()
   if not options then
      options = {
         type = "group",
         args = {
            general = {
               type = "group",
               inline = true,
               name = "",
               args = {
                  
				  -- ProfilesSynch = {
                     -- type = "toggle",
                     -- name = "Synchronize with the Profile: Addons series",
                     -- desc = "",
                     -- order = 101,
                     -- width = "full",
                     -- get = getOpt,
                     -- set = function (info,value) 
                        -- if KPSdb.char.KLSaddonEnabled == 0 then 
                           -- KPSdb.char.KLSaddonEnabled = 1
                           -- KPS:Enable()
                        -- else
                           -- KPSdb.char.KLSaddonEnabled = 0
                           -- KPS:Disable()
                        -- end
                     -- end,
                  -- },
				  
                  PABLoadProfileAtStart = {
                     type = "toggle",
                     name = "Load profile at start",
                     desc = "",
                     order = 101,
                     width = "full",
                     get = getOpt,
                     set = function (info,value) 
                        local dbg = setOpt(info, value)
                     end,
                  },
				  
				  PABshow_minimap_icon = {
                     type = "toggle",
                     name = "Hide minimap button",
                     desc = "Hide the minimap. If you hide it, you need to use the slash commands.",
                     order = 102,
                     width = "full",
                     get = getMinimapValue,
                     set = function (info,value)
                        PAB:Minimap(value)
                     end,
                  },
				  
				  PAB_Unoptimized_load = {
                     type = "toggle",
                     name = "Unoptimized load of profile",
                     desc = "WARNING: Enabling this might lock your client for a couple of seconds! ",
                     order = 103,
                     width = "full",
                     get = getOpt,
                     set = function (info,value) 
                        local dbg = setOpt(info, value)
                        PAB:Echo("enabled!") 
                     end,
                  },
				  Unoptimized_load_descr = {
                     type = "description",
                     name = "Removes undefined actionbar slots.",
                     order = 104,
					},
				  warning = {
                     type = "description",
                     name = "|cffff0000WARNING! Turning on unoptimized unoptimized might lock up your client everytime you load a new profile!",
                     order = 105,
					},
				 
               },
			   },
         },
      }
      for k,v in pairs(moduleOptions) do
         options.args[k] = (type(v) == "function") and v() or v
      end
   end
   return options
end


function PAB:SetupOptions()
   self.optFrames = {}
   LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("ProfilesActionBars", getOptions)
   self.optFrames.PAB = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ProfilesActionBars", "Profiles: Action Bars", nil, "general")
   --self:RegisterModuleOptions("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db), "Profiles")
end

function PAB:RegisterModuleOptions(name, optTable, displayName)
   moduleOptions[name] = optTable
   self.optFrames[name] = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("ProfilesActionBars", displayName or name, "ProfilesActionBars", name)
end
